%% alte Variablen weg, Wave laden
clear all;
[a, fs] = wavread('C:\Users\jl\Desktop\test.wav');
sound(a, fs, 16);

%% Sound abschneiden und umkehren
b = a(end/4:end/3, :); % Ausschnitt
sound(b, fs, 16);
b = a(end:-1:1, :); % rckwrts
sound(b, fs, 16);

%% Audioplayer starten und Stand des Playheads anzeigen
plr = audioplayer(a, fs);
total = get(plr, 'TotalSamples');
play(plr); % asynchron, notfalls mit stop (plr) beenden
while strcmp(get(plr,'Running'), 'on')
    display(get(plr, 'CurrentSample') / total);
    pause(0.2);
end

%% Audioaufnahme im Hintergrund
rcdr = audiorecorder(fs, 16, 1);
record(rcdr);
pause(2.0); % besser auf einen Mausklick warten o..
stop(rcdr);
c = getaudiodata(rcdr);
sound(c, fs, 16);

%% Sinus erzeugen
d = sin(2*pi*440/fs*(0:fs));
sound(d, fs, 16);

%% weich gefadete zufllige Ausschnitte zufllig montieren
dur = fs*10;
durPart = fs*0.5;
e = zeros(dur, 2);
wdw = [hann(durPart), hann(durPart)];
for i=1:100
    x = randi(length(a) - durPart + 1);
    y = randi(dur - durPart + 1);
    e(y:y+durPart-1, :) = e(y:y+durPart-1, :) + wdw.*a(x:x+durPart-1, :);
end
soundsc(e, fs, 16);

%% Wellenform anzeigen
subplot(2, 1, 1);
plot((1:length(a))/fs, a(:, 1));
xlabel('Zeit/s');
title('Eine tolle Wellenform links');
subplot(2, 1, 2);
plot((1:length(a))/fs, a(:, 2));
xlabel('Zeit/s');
title('Eine tolle Wellenform rechts');

%% Spektrogramm anzeigen
% Achtung, wenn MIRtoolbox installiert:
% Erst Auditory Toolbox aus dem Pfad nehmen.
spectrogram(a(:, 1)+a(:, 2), 4096, 16, 4096, fs);
view(90, -90);

%% Normalisieren
f = a/max(abs(a(:)));

%% Hllkurve erzeugen und anzeigen
mono = 0.5*(a(:, 1) + a(:, 2));
env = zeros(length(mono), 1);
amp = 0;
for i = 1:length(mono)
    diff = abs(mono(i)) - amp;
    if diff > 0
        amp = amp + 0.01*diff;
    else
        amp = amp + 0.0005*diff;
    end
    env(i) = amp;
end
plot((1:length(mono))/fs, mono, ...
    (1:length(mono))/fs, env);

%% Pausen brutal wegschneiden
trimmed = zeros(length(mono), 1);
j = 1;
for i = 1:length(mono)
    if env(i) > 0.1
        trimmed(j) = mono(i);
        j = j+1;
    end  
end
trimmed = trimmed(1:j);
sound(trimmed, fs, 16);

%% Filter bauen und anwenden
[bi, ai] = butter(2, [400*2/fs, 480*2/fs]);
g = filter(bi, ai, a((end/4):(end/3), 1));
soundsc(g, fs, 16);

%% Filter Visualization Tool
fvtool(bi, ai);

%% Filter Design and Analysis Tool
fdatool;